# Machine Learning

## Optimization

In machine learning, we need some form of optimization techniques, one of them being an algorithm commonly used, called gradient descent.

* [Gradient Descent](https://github.com/sotostzam/artificial-intelligence/tree/master/machine-learning/gradient-descent)

## Supervised Learning

### Classification / Regression

* [Linear Regression](https://github.com/sotostzam/artificial-intelligence/tree/master/machine-learning/linear-regression) (Used for regression analysis)
* [K-Nearest Neighbors](https://github.com/sotostzam/artificial-intelligence/tree/master/machine-learning/k-nearest-neighbors) (Used for classification and regression)
* [Support Vector Machines](https://github.com/sotostzam/artificial-intelligence/tree/master/machine-learning/support-vector-machine) (Used for classification and regression)
* [Naive Bayes](https://github.com/sotostzam/artificial-intelligence/tree/master/machine-learning/naive-bayes) (Used for classification)

### Artificial Neural Networks

Artificial neural networks (ANNs) are tools widely used in machine learning. They are brain inspired algorithms which replicate the way human beings think and learn. They consist of layers which are called input, hidden and output layers respectively. Deep neural networks usually include a lot of hidden layers (more than one) to produce far more reliable results and improve the learning process.

* [Perceptron](https://github.com/sotostzam/artificial-intelligence/tree/master/machine-learning/perceptron)
* [Multilayer Perceptron](https://github.com/sotostzam/artificial-intelligence/tree/master/machine-learning/multilayer-perceptron)

## Unsupervised Learning

### Clustering

* [k-means](https://github.com/sotostzam/artificial-intelligence/tree/master/machine-learning/k-means)
* [Partition Around Medoids (PAM)](https://github.com/sotostzam/artificial-intelligence/tree/master/machine-learning/partition-around-medoids)
* [Mean shift](https://github.com/sotostzam/artificial-intelligence/tree/master/machine-learning/mean-shift)
* [Fuzzy c-means](https://github.com/sotostzam/artificial-intelligence/tree/master/machine-learning/fuzzy-c-means)
* [Self Organizing Maps (SOM)](https://github.com/sotostzam/artificial-intelligence/tree/master/machine-learning/self-organizing-map)
* [Kernel k-means](https://github.com/sotostzam/artificial-intelligence/tree/master/machine-learning/kernel-k-means)

## Reinforcement Learning

Reinforcement learning (RL) is a subset of machine learning that makes use of software agents, which take actions in a given environment. Their goal is to maximize a cumulative reward.

* [Q-Learning](https://github.com/sotostzam/artificial-intelligence/tree/master/machine-learning/q-learning)

## How to run code

In order to run the examples you need to have the following requirements:

1) [Python 3](https://www.python.org/downloads/)
2) [NumPy](http://www.numpy.org/)
3) [Matplotlib](http://matplotlib.org/)
4) [Pandas](https://pandas.pydata.org/)
5) [Scikit-learn](https://scikit-learn.org/stable/)

For your convenience there is a file named requirements, which holds the information about all the required libraries. After making sure you have python up and running in your machine, you can install all the requirements by using the following command:

```Python
pip install -r requirements.txt
```
