# Problem Solving

Given a problem and a description of its state space, we want to find a solution. To achieve that, we have to apply a sequence of strictly predetermined steps, also known as algorithms. All algorithms that fall into that category, meaning they try to find a solution to a problem, are called search algorithms.

## Blind and Informed Search Algorithms

* [Romania map path finder implementing various search algorithms](https://github.com/sotostzam/artificial-intelligence/tree/master/problem-solving/search-algorithms)
* [Maze solver using the A* search algorithm](https://github.com/sotostzam/artificial-intelligence/tree/master/problem-solving/maze-a-star)

## Two-person Games Search

* [Tic Tac Toe game using minimax and alpha-beta prunning](https://github.com/sotostzam/artificial-intelligence/tree/master/problem-solving/tic-tac-toe-minimax)

## Constraint Satisfaction Problems

* [Coloring the map of Australia using backtracking](https://github.com/sotostzam/artificial-intelligence/tree/master/problem-solving/coloring-map-csp)
* [N-Queens Problem using backtracking and MRV](https://github.com/sotostzam/artificial-intelligence/tree/master/problem-solving/n-queen-problem)

## Genetic Algorithms

* [Traveling salesman Problem](https://github.com/sotostzam/artificial-intelligence/tree/master/problem-solving/traveling-salesman-problem)
